/*
Copyright (C) 2001 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
funcpars@hendriklipka.de
*/

package de.hendriklipka.funcpars;

public class Test
{

    public Test()
    {
        doTest("1+2",3);
        doTest("1+2-sin(1+3)*3",5.270407485923784);
        doTest("1+2*3",7);
        doTest("2*3+1",7);
        doTest("2*(3+1)",8);
        doTest("1+-2",-1);
        doTest("-1+4",3);
        doTest("-sin(4)",0.7568024953079282);
        doTest("-3+3",0);
        doTest("-3*-4",12);
        doTest("x+y",1,2,0,3);
        doTest("x+y",3,2,0,5);
        doTest("x+y+z",1,2,1,4);
    }

    protected void doTest(String s, double x, double y, double z, double expResult)
    {
        FunctionParser fp=null;
        try
        {
            System.out.println("formula="+s);
            fp=new FunctionParser(s);
            double d=fp.parse(x,y,z);
            System.out.println("result="+d);
            if ((expResult-d)>0.000001)
            {
                System.out.println("result is not close enough to expected result ("+expResult+"), dumping RPN");
                fp.DumpRPN();
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            System.out.println("dumping RPN:");
            fp.DumpRPN();
        }
        System.out.println();
    }

    protected void doTest(String s, double expResult)
    {
        doTest(s,0,0,0,expResult);
    }
    public static void main(String[] args)
    {
        Test test1 = new Test();
    }
}